#include <iostream>
#include <fstream>
#include <vector>
#include <cstring>

using namespace std;

struct coordinates{int s; int e;};
bool to_lower(char *& product);
bool is_phage(char * product);
int remove_phage(char * acc, const char * file_seq, const char * path_in_ptt, const char * path_out);

// argv[1]=path to fastas; argv[2]=file with fastas; argv[3]=path to ptts; argv[4]=path to output
int mainXXXX(int argc, char** argv)
{///home/catherine/Desktop/forThomas/FastaFiles/ temp.x /home/catherine/Desktop/forThomas/FastaFiles/ /home/catherine/Desktop/forThomas/FastaFiles/masked/

    for(int i=0; i<argc; i++) cout << argv[i] << endl;
    return 1;
}

int main(int argc, char** argv)
{
    int i,j;
    vector<string> files_fasta;

    ifstream in;
    char line[1000];
    sprintf(line,"%s%s", argv[1], argv[2]);
    in.open(line);    //open genome files
    while(in.peek()!=EOF)
    {
        in.getline(line,1000,'\n');
        files_fasta.push_back(line);
    }
    in.clear();
    in.close();
    int num_genomes_fasta=files_fasta.size();
    char * acc;
    int len_path, len_total;

    for(i=0; i<num_genomes_fasta; i++)
    {
        len_path=strlen(argv[1]);
        len_total=files_fasta[i].size();
        acc=new char [len_total-len_path];
        for(j=len_path; j<(len_total-4); j++)
            acc[j-len_path]=files_fasta[i][j];
        acc[j-len_path]='\0';

        remove_phage(acc, files_fasta[i].c_str(), argv[3], argv[4]);
        delete acc;
    }

    return 1;
}


int remove_phage(char * acc, const char * file_seq, const char * path_in_ptt, const char * path_out)
{
    int i,j,len;

    char file_ptt[500];
    sprintf(file_ptt,"%s%s.ptt",path_in_ptt,acc);
    cout << file_ptt << endl;
    char out_file[500];
    sprintf(out_file,"%s%s_masked.fna",path_out,acc);
    cout << out_file << endl;

    char header[1000];
    char * junk=new char [5000];
    char c;
    coordinates temp_c;
    vector<coordinates> v;

    ifstream in;

    //get list of coordinates of genes of interest FOR EXCLUSION
    in.open(file_ptt);
    if(in.is_open())
    {
        in.getline(header,5000,'\n'); in.getline(junk,5000,'\n'); in.getline(junk,5000,'\n');
        while(in.peek()!=EOF)
        {
            in>>i; in>>c; in>>c; in>>j; temp_c.s=i-1; temp_c.e=j-1;
            in.getline(junk,5000,'\t');  //gets tab after location
            in.getline(junk,5000,'\t');  //gets strand
            in.getline(junk,5000,'\t');  //gets length
            in.getline(junk,5000,'\t');  //gets PID
            in.getline(junk,5000,'\t');  //gets gene
            in.getline(junk,5000,'\t');  //gets synonym
            in.getline(junk,5000,'\t');  //gets code
            in.getline(junk,5000,'\t');  //gets COG
            in.getline(junk,5000,'\n');  //gets Product

            to_lower(junk);
            if(is_phage(junk))
                v.push_back(temp_c);
        }
    }
    in.clear();
    in.close();

    //get length of genome
    in.open(file_seq);
    in.getline(header,1000,'\n');
    len=0;
    while(in.peek()!=EOF)
    {
        in>>c;
        if(c!='\0')
            len++;
    }
    len--;
    in.clear();
    in.close();

    char * sequence=new char [len];

    in.open(file_seq);
    in.getline(header,500,'\n');
    for(i=0;i<len;i++) in>>sequence[i];
    in.clear();
    in.close();

    for(i=0;i<v.size();i++)
    {
        for(j=v[i].s;j<v[i].e;j++)
            sequence[j]='N';
    }

    ofstream out;
    out.open(out_file, std::ios::out|std::ios::binary);
    out<<header<<endl;
    cout << header << "\t" << len << endl;
    for(i=0;i<len;i++)
    {
        if( !(c<65 || c>122) )
        {
            out << sequence[i];
            if((i+1)%70==0) out << endl;
        }
    }
    out.clear();
    out.close();

    delete sequence;
    delete junk;
    v.clear();

    return 0;
}

bool to_lower(char *& product)
{
    int i;
    for(i=0;i<strlen(product);i++)
    {
        if( (product[i]>64) && (product[i]<91)) product[i]+=32;
    }
    return true;
}


bool is_phage(char * product)
{
    char * pch;
    to_lower(product);
    pch=strstr(product,"macropha");
    if(pch!=NULL) return false;
    pch=strstr(product,"phage");
    if(pch!=NULL) return true;
    pch=strstr(product,"virus");
    if(pch!=NULL) return true;
    pch=strstr(product,"viral");
    if(pch!=NULL) return true;
    return false;
}
